• leetcode 63. Unique Paths II


    A robot is located at the top-left corner of a m x n grid (marked 'Start' in the diagram below).

    The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked 'Finish' in the diagram below).

    Now consider if some obstacles are added to the grids. How many unique paths would there be?

    An obstacle and empty space is marked as 1 and 0 respectively in the grid.

    Note: m and n will be at most 100.

    Example 1:

    Input:
    [
      [0,0,0],
      [0,1,0],
      [0,0,0]
    ]
    Output: 2
    Explanation:
    There is one obstacle in the middle of the 3x3 grid above.
    There are two ways to reach the bottom-right corner:
    1. Right -> Right -> Down -> Down
    2. Down -> Down -> Right -> Right

    思路:动态规划

    dp[i][j]表示到达(i, j)的路径数, 对于一般情况,由于只能向右或者向下,dp[i][j] = dp[i - 1][j] + dp[i][j - 1]

     1 class Solution {
     2 public:
     3     int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
     4         int m = obstacleGrid.size();
     5         if (m == 0) {
     6             return 0;
     7         }
     8         int n = obstacleGrid[0].size();
     9         vector<vector<long long> > dp(m + 1, vector<long long>(n + 1, 0));
    10         if (obstacleGrid[0][0] == 0) //左上角为0,说明可以达到这个点,方法数为1
    11             dp[0][0] = 1;
    12         else
    13             return 0;
    14         for (int j = 1; j < n; j++) {
    15             if (obstacleGrid[0][j] == 0)
    16                 dp[0][j] = dp[0][j - 1];
    17             else
    18                 dp[0][j] = 0;
    19         }
    20         for (int i = 1; i < m; i++) {
    21             if (obstacleGrid[i][0] == 0)
    22                 dp[i][0] = dp[i - 1][0];
    23             else
    24                 dp[i][0] = 0;
    25         }
    26         for (int i = 1; i < m; i++) {
    27             for (int j = 1; j < n; j++) {
    28                 if (obstacleGrid[i][j] == 0) { //如果(i, j)这个点没有障碍,那么达到这个点的路径数为(i-1, j) + (i, j - 1)
    29                     dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
    30                 } else {
    31                     dp[i][j] = 0;
    32                 }
    33             }
    34         }
    35         return dp[m - 1][n - 1];
    36     }
    37 };
  • 相关阅读:
    【Object-C】判断指针类型,isKindOfxxx
    【Object-C】继承,super关键字
    Echart的angularjs封装
    ng-validate
    random background
    新发现。css3控制浏览器滚动条的样式
    如何灵活利用免费开源图标字体-IcoMoon篇
    干货分享:让你分分钟学会 javascript 闭包
    webpack
    css黑魔法
  • 原文地址:https://www.cnblogs.com/qinduanyinghua/p/11517922.html
Copyright © 2020-2023  润新知